//
//  AnnualReportViewController.swift
//  sKakeibo
//
//  Created by 梅山 新一郎 on 2018/10/29.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa
import Quartz
class AnnualReportViewController: NSViewController,NSTableViewDataSource, NSTableViewDelegate, NSComboBoxDataSource, NSComboBoxDelegate{

    private var firstApper: Bool = false
    override func viewWillAppear() {
        super.viewWillAppear()
        if !firstApper {
            firstApper = true
            if !DM.readYearsFromItemsTable(){
                dismiss(self)
            }
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        tblItemsIn.dataSource = self
        tblItemsIn.delegate = self
        tblItemsOut.dataSource = self
        tblItemsOut.delegate = self
        tblTotals.dataSource = self
        tblTotals.delegate = self
        cmbYears.usesDataSource = true
        cmbYears.dataSource = self
        cmbYears.delegate = self
        

        
    }
    
    @IBAction func btnPDF(_ sender: Any) {
        var names = [String](); var data = [[Int]]()
        
        for (s, dt) in zip(DM.annualInNameList, DM.annualInDataList){
            names.append(s); data.append(dt) }
     names.append(DM.annualTotalNameList[0]);data.append(DM.annualTotalDataList[0])
        
        for (s, dt) in zip(DM.annualOutNameList, DM.annualOutDataList) {
            names.append(s); data.append(dt) }
    names.append(DM.annualTotalNameList[1]);data.append(DM.annualTotalDataList[1])
    names.append(DM.annualTotalNameList[2]);data.append(DM.annualTotalDataList[2])
        let rowOfIncomeTotal = DM.annualInNameList.count + 2
        let rowOfSpenddingTotal = rowOfIncomeTotal + DM.annualOutNameList.count + 1
        
        let aPdfDoc = PDFDocument()
        let numberOfDatasRowsPerPage = 24
        var numberOfPages = names.count / numberOfDatasRowsPerPage
        if names.count % numberOfDatasRowsPerPage > 0{
            numberOfPages += 1
        }
        
        var rowOffsetOfIncomeTotal:Int; var rowOffsetOfSpenddingTotal:Int
        for i in 0 ..< numberOfPages{
            let startIndex = i * numberOfDatasRowsPerPage
            var endIndex = i * numberOfDatasRowsPerPage + numberOfDatasRowsPerPage
            if endIndex >  names.count{
                endIndex = names.count
            }
            
            let pdfNames:[String] = Array(names[startIndex..<endIndex])
            let pdfData:[[Int]] = Array(data[startIndex..<endIndex])
            if case startIndex...endIndex = rowOfIncomeTotal {
                rowOffsetOfIncomeTotal = rowOfIncomeTotal - i * numberOfDatasRowsPerPage
            }else{
                rowOffsetOfIncomeTotal = -1
            }
            if case startIndex...endIndex = rowOfSpenddingTotal {
                rowOffsetOfSpenddingTotal = rowOfSpenddingTotal - i * numberOfDatasRowsPerPage
            }else{
                rowOffsetOfSpenddingTotal = -1
            }
            
            
            let aPage = AnnualReportPDFPage(nendo:DM.yearsList[cmbYears.indexOfSelectedItem], names: pdfNames, data: pdfData, rowOffsetOfIncomeTotal: rowOffsetOfIncomeTotal, rowOffsetOfSpenddingTotal: rowOffsetOfSpenddingTotal)
            aPdfDoc.insert(aPage, at: i)
            
        }
        
        let FS = NSSavePanel()
        FS.canCreateDirectories = true
        FS.allowedFileTypes = ["pdf", "PDF"]
        if FS.runModal() == NSApplication.ModalResponse.OK{
            let fileURL = FS.url
            let strFS = (fileURL?.path)!
            aPdfDoc.write(toFile: strFS)
        }
        
    }
    
    @IBAction func btnCSV(_ sender: Any) {
        let DF = DateFormatter()
        DF.dateFormat = "YYYY年MM月dd日"
        DF.timeZone = NSTimeZone.local
        var fileStrData:String = DM.yearsList[cmbYears.indexOfSelectedItem] + " 年度 ,　" + DF.string(from: Date()) + "\n"
        fileStrData += "名 称 ,"
        for m in 1...12{
            fileStrData += (String(m) + "月,")
        }
        fileStrData += " 金　額 \n"
        
        let FS = NSSavePanel()
        FS.canCreateDirectories = true
        FS.allowedFileTypes = ["csv", "CSV"]
        if FS.runModal() == NSApplication.ModalResponse.OK{
            let fileURL = FS.url
            let strFS = (fileURL?.path)!
            for (name, dt) in zip(DM.annualInNameList, DM.annualInDataList){
                fileStrData += name
                for i in dt{
                    fileStrData += ("," + String(i))
                }
                fileStrData +=  " \n"
            }
            fileStrData += DM.annualTotalNameList[0]
            for i in DM.annualTotalDataList[0]{ fileStrData += ("," + String(i))}
            fileStrData +=  " \n"
            
            for (name, dt) in zip(DM.annualOutNameList, DM.annualOutDataList){
                fileStrData += name
                for i in dt{
                    fileStrData += ("," + String(i))
                }
                fileStrData +=  " \n"
            }
            fileStrData += DM.annualTotalNameList[1]
            for i in DM.annualTotalDataList[1]{ fileStrData += ("," + String(i))}
            fileStrData +=  " \n"
            fileStrData += DM.annualTotalNameList[2]
            for i in DM.annualTotalDataList[2]{ fileStrData += ("," + String(i))}
            fileStrData +=  " \n"


            do{
                try fileStrData.write(toFile: strFS, atomically: true, encoding: String.Encoding.utf8)
            }catch let error as NSError{
                print("annual report csv write error \n\(error)")
            }
        }
    }
    
    
    @IBOutlet weak var cmbYears: NSComboBox!
    func numberOfItems(in comboBox: NSComboBox) -> Int {
        return DM.yearsList.count
    }
    func comboBox(_ comboBox: NSComboBox, objectValueForItemAt index: Int) -> Any? {
        return DM.yearsList[index]
    }
    func comboBoxSelectionDidChange(_ notification: Notification) {
        guard DM.annualInOutFromItemsTable(nen: DM.yearsList[cmbYears.indexOfSelectedItem]) else{return}
        
        tblItemsIn.reloadData()
        tblItemsOut.reloadData()
        tblTotals.reloadData()
        
    }
    
    @IBOutlet weak var tblItemsIn: NSTableView!
    @IBOutlet weak var tblItemsOut: NSTableView!
    @IBOutlet weak var tblTotals: NSTableView!
    
    
    func numberOfRows(in tableView: NSTableView) -> Int {
        if tableView.tag == 0{ //tblItemsIn
            return DM.annualInNameList.count
        }else if tableView.tag == 1{//tblItemsOut
            return DM.annualOutNameList.count
        }else {                     //tblTotals
            return DM.annualTotalDataList.count
        }
    }
    
    let dicColNo = ["00":0, "01":1, "02":2, "03":3, "04":4, "05":5, "06":6, "07":7, "08":8, "09":9, "10":10, "11":11, "12":12, "13":13]
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        
        guard let colNo = dicColNo[tableColumn!.identifier.rawValue] else{return nil}
        if tableView.tag == 0{ //tblItemsIn
            switch colNo{
            case 0:
                vw.textField?.stringValue = DM.annualInNameList[row]
            case 1...13:
                vw.textField?.integerValue = DM.annualInDataList[row][colNo - 1]
            default:
                return nil
            }
        }else if tableView.tag == 1{//tblItemsOut
            switch colNo{
            case 0:
                vw.textField?.stringValue = DM.annualOutNameList[row]
            case 1...13:
                vw.textField?.integerValue = DM.annualOutDataList[row][colNo - 1]
            default:
                return nil
            }
        }else {                     //tblTotals
            switch colNo{
            case 0:
                vw.textField?.stringValue = DM.annualTotalNameList[row]
            case 1...13:
                vw.textField?.integerValue = DM.annualTotalDataList[row][colNo - 1]
            default:
                return nil
            }
        }
        return vw
    }


func someMessageWithAlert(_ message: String, _ textInfo:String = "information") {
    let alert = NSAlert()
    alert.messageText = message
    alert.informativeText = textInfo
    alert.runModal()
}
}
