//
//  DataModel.swift
//  sKakeibo
//
//  Created by 梅山 新一郎 on 2018/07/28.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa
import SQLite3

class DataModel{//---------------------
    
    static let sharedInstance = DataModel()
    
    
    
    var sisanList = [Sisan]()
    var sisanId2Idx = [Int : Int]()
    var sisanIdx2Id = [Int : Int]()
    
    var itemList = [Items]()
    var itemId2Idx = [Int : Int]()
    var itemIdx2Id = [Int : Int]()

    var himokuList = [Himoku]()
    var himokuId2Idx = [Int : Int]()
    var himokuIdx2Id = [Int : Int]()

    var TotalZankin = 0
    var GrandTotalSisan = 0
    
    var yearsList = [String]()
    var annualInNameList = [String]()
    var annualInDataList = [[Int]]()
    var annualOutNameList = [String]()
    var annualOutDataList = [[Int]]()
    var annualTotalNameList = ["収　入　計", "支　出　計", "差　引　合　計"]
    var annualTotalDataList = [[Int]]()
    
    
    
    
    
    fileprivate var db: OpaquePointer?
    fileprivate var stmt: OpaquePointer?
    fileprivate var strPath = Bundle.main.resourcePath! + "/sKakeibo.sql"
    
    var theSyubetuNo = 0 //1:支出, 2:収入, 3:移動支出, 4:移動収入
    var theSisanNo = 0   //sisanListIndex
    
    private init(){
        
        //Set up data file path and load saved data
        //let strP =  (Bundle.main.bundlePath).split(separator: "/")
        //strPath = (strP[..<(strP.count - 1)]).joined(separator: "/") + "/sKakeibo.sql"
        //someMessageWithAlert("path:" + strPath)
        //strPath =  "/Users/umeya/Desktop/temp/test/sKakeibo.sql" // for test only
        
        // if file exists, load saved data ,else create DB and create table
//        if !FileManager.default.fileExists(atPath: strPath){
//            createDB()
//        }
        
        openDB()
        
        //readValue()
        guard readFromSisanTable() else{return}
        guard readFromHimokuTable() else{return}
       
    }
    
//    func createDB(){
//
//        //let fm = FileManager()
//        let atpath : String = Bundle.main.resourcePath! + "/sKakeibo.sql"
//        //someMessageWithAlert("atpath:" + atpath)
//        do{
//            //try fm.copyItem(atPath: atpath, toPath: strPath)
//            try  FileManager.default.copyItem(atPath: atpath, toPath: strPath)
//
//        } catch let error as NSError{
//            someMessageWithAlert(  "error create DB(copyfrom resource to current directory: \(error)")
//        }
    
//    }
    
    func openDB(){
        
        if sqlite3_open(strPath, &db) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error open database : \(errmsg)" , "stop the app")
            return
        }
    }
    
    func closeDB(){
        if sqlite3_close( db ) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error close database table: \(errmsg)" , "stop the app")
        }
    }
    
    func readValue(){
       
        
        guard readFromSisanTable() else{return}
        guard readFromHimokuTable() else{return}
        guard readFromItemsTable(sisanList[theSisanNo].Id) else {return}
        
    }

    // sisan table -----------------------------------------------

    
    func readFromSisanTable() -> Bool{
        //first empty the list of heros
        sisanList.removeAll()
        GrandTotalSisan = 0
        sisanId2Idx.removeAll(); sisanIdx2Id.removeAll()
        
        //this is our seleted query
        let queryString = "SELECT * FROM Sisan"
        
        //statement pointer
        //var stmt: OpaquePointer?
        
        //prepare the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare selct from sisan: \(errmsg)" , "stop the app")
            return false
        }
        
        //traversing through all records
        var idx = -1
        while (sqlite3_step(stmt) == SQLITE_ROW) {
            let Id = sqlite3_column_int(stmt, 0)
            let Namae = String(cString: sqlite3_column_text(stmt, 1))
            let SyokiKingaku = sqlite3_column_int(stmt, 2)
            let Zankin = sqlite3_column_int(stmt, 3)
            
            GrandTotalSisan += Int(Zankin)
            //adding values to list
            sisanList.append(Sisan(Id: Int(Id), Namae: String(describing: Namae), SyokiKingaku:Int(SyokiKingaku), Zankin: Int(Zankin)))
            idx += 1
            sisanId2Idx[Int(Id)] = idx; sisanIdx2Id[idx] = Int(Id)
        }
        sqlite3_finalize(stmt)
        return true
    }
    
    func updateSisanZankinList(_ sisanId:Int, _ total:Int){
        for (idx, s) in sisanList.enumerated(){
            if s.Id == sisanId{
                sisanList[idx].Zankin = total
                return
            }
        }
        someMessageWithAlert("error updateSisanZankinList")
    }
    
    func updateSisanZankinTable()->Bool{
        var queryString = ""
        let qs0 = "UPDATE Sisan SET Zankin="
        let qs1 = " WHERE Id="
        //statement pointer
        //var stmt: OpaquePointer?
        
        for s in sisanList{
            queryString = qs0 + String(s.Zankin) + qs1 + String(s.Id)
            //prepare the query
            if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
                let errmsg = String(cString: sqlite3_errmsg(db)!)
                someMessageWithAlert("error prepare update sisan: \(errmsg)" , "stop the app")
                return false
            }
            
            //execute the query to insert values
            if sqlite3_step(stmt) != SQLITE_DONE {
                let errmsg = String(cString: sqlite3_errmsg(db)!)
                someMessageWithAlert("failure updating sisan Zankin: \(errmsg)")
                return false
            }
            
        }
        sqlite3_finalize(stmt)
        return true
    }
    
    
    func sisanInsert(_ namae:String, _ kingaku:Int) -> Bool {
        
        //the insert quary
        let queryString = "INSERT INTO Sisan (Namae,SyokiKingaku,Zankin) VALUES (?,?,?)"
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing Syukkin,Nyuukin insert: \(errmsg)")
            return false
        }
        
        
        guard bind_text(1, namae)else{someMessageWithAlert("error insert Column Namae"); return false}
        guard bind_int(2, kingaku) else{someMessageWithAlert("error insert Column SyokiKingaku "); return false}
        guard bind_int(3, kingaku) else{someMessageWithAlert("error insert Column Zankin "); return false}

        
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting sisan : \(errmsg)")
            return false
        }
        
        sqlite3_finalize(stmt)
        
        return readFromSisanTable()
    }

    
    func sisanUpdate(_ id:Int, _ namae:String, _ syokiKingaku:Int, _ zankin:Int) -> Bool{
        let queryString = "UPDATE Sisan SET Namae= '" + namae + "' , SyokiKingaku=" + String(syokiKingaku) + " , Zankin=" + String(zankin) + " WHERE Id=" + String(id)

        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update sisan: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating sisan: \(errmsg)")
            return false
        }

        sqlite3_finalize(stmt)
        return readFromSisanTable()
        
    }

    func sisanDelete(_ id:Int) -> Bool{
        let queryString = "DELETE FROM Sisan WHERE Id=" + String(id)
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing delete sisan: \(errmsg)")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure deletin from sisan: \(errmsg)")
            return false
        }
        sqlite3_finalize(stmt)
        return readFromSisanTable()

    }

    //Himoku table---------------------------------------------------------------
    
    func readFromHimokuTable() -> Bool{
        //first empty the list of heros
        himokuList.removeAll()
        
        himokuId2Idx.removeAll(); himokuIdx2Id.removeAll()
        
        //this is our seleted query
        let queryString = "SELECT * FROM Himoku ORDER BY SyubetuNo, Id"
        
        //statement pointer
        //var stmt: OpaquePointer?
        
        //prepare the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare selct from himoku: \(errmsg)" , "stop the app")
            return false
        }
        
        //traversing through all records
        var idx = -1
        while (sqlite3_step(stmt) == SQLITE_ROW) {
            let Id = sqlite3_column_int(stmt, 0)
            let SyubetuNo = sqlite3_column_int(stmt, 1)
            let Namae = String(cString: sqlite3_column_text(stmt, 2))
            let Hno = sqlite3_column_int(stmt, 3)
            let Ucount = sqlite3_column_int(stmt, 4)
            
            //adding values to list
            himokuList.append(Himoku(Id: Int(Id),SyubetuNo: Int(SyubetuNo),  Namae: String(describing: Namae), Hno:Int(Hno), Ucount: Int(Ucount)))
            idx += 1
            himokuIdx2Id[Int(Id)] = idx; himokuIdx2Id[idx] = Int(Id)
        }

        sqlite3_finalize(stmt)

        return true

    }
    
    func insertHimokuOfHiimoku(_ syubetuno:Int, _ himokumei:String) -> Bool{
        
        //insert new Himoku -----------------------------------
        //the insert quary
        var queryString = "INSERT INTO Himoku (SyubetuNo, Namae, Hno, Ucount) VALUES (?,?,?,?)"
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing HimokumeiOfHimoku insert: \(errmsg)")
            return false
        }
        
        guard bind_int(1, syubetuno) else{someMessageWithAlert("error insert Column SyubetuNo "); return false}
        guard bind_text(2, himokumei)else{someMessageWithAlert("error insert Column Namae"); return false}
        guard bind_int(3, 0) else{someMessageWithAlert("error insert Column Hno "); return false}
        guard bind_int(4, 1) else{someMessageWithAlert("error insert Column Ucount "); return false}
        
        
        
        
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting himoku : \(errmsg)")
            return false
        }
        
        
        let rowId = Int(sqlite3_last_insert_rowid(db))
 
        //insert new utiwake for new himoku
        queryString = "INSERT INTO Himoku (SyubetuNo, Namae, Hno, Ucount) VALUES (?,?,?,?)"
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing HimokumeiOfHimoku insert: \(errmsg)")
            return false
        }
        guard bind_int(1, syubetuno) else{someMessageWithAlert("error insert Column SyubetuNo "); return false}
        guard bind_text(2, himokumei + "/その他")else{someMessageWithAlert("error insert Column Namae"); return false}
        guard bind_int(3, rowId) else{someMessageWithAlert("error insert Column Hno "); return false}
        guard bind_int(4, 0) else{someMessageWithAlert("error insert Column Ucount "); return false}
        
    
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting himoku : \(errmsg)")
            return false
        }
        
        // update new himokurecord
        queryString = "UPDATE Himoku SET Hno= " + String(rowId) + " WHERE Id=" + String(rowId)
        
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update HnoOfHimoku for insert himokumei: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating HnoOfHimoku for insert himokumei: \(errmsg)")
            return false
        }
        
        sqlite3_finalize(stmt)
        
        return readFromHimokuTable()
    }
    
    func insertUtiwakeOfHimoku(syubetuno:Int, utiwake:String, hno:Int, ucount0:Int)->Bool{
        
        //insert new Utiwake -----------------------------------
        //the insert quary
        var queryString = "INSERT INTO Himoku (SyubetuNo, Namae, Hno, Ucount) VALUES (?,?,?,?)"
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing UtiwakemeiOfHimoku insert: \(errmsg)")
            return false
        }
        
        guard bind_int(1, syubetuno) else{someMessageWithAlert("error insert Column SyubetuNo "); return false}
        guard bind_text(2, utiwake)else{someMessageWithAlert("error insert Column Namae"); return false}
        guard bind_int(3, hno) else{someMessageWithAlert("error insert Column Hno "); return false}
        guard bind_int(4, 0) else{someMessageWithAlert("error insert Column Ucount "); return false}
        
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting utiwake : \(errmsg)")
            return false
        }
        
        
        // update  himoku Ucount of Utiwake
        queryString = "UPDATE Himoku SET Ucount= " + String(ucount0 + 1) + " WHERE Id=" + String(hno)
        
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update Ucount O fHimoku for update himokumei: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating Ucount Of Himoku for update himokumei: \(errmsg)")
            return false
        }
        
        sqlite3_finalize(stmt)
        
        return readFromHimokuTable()
    }
    
    
    
    func updateHnoOfHimoku(_ id:Int, _ hno:Int)->Bool{
        let queryString = "UPDATE Himoku SET Hno= " + String(hno) + " WHERE Id=" + String(id)
        
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update HnoOfHimoku: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating HnoOfHimoku: \(errmsg)")
            return false
        }
        
        sqlite3_finalize(stmt)
        return true
    }
    
    func updateNamaeOfHimoku(id:Int, himokuNamae:String, utiwakeids:[Int], utiwakeNamaes:[String])->Bool{
        var queryString = "UPDATE Himoku SET Namae= '" + himokuNamae + "' WHERE Id=" + String(id)
        
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update Namae Of Himoku: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating Namae Of Himoku: \(errmsg)")
            return false
        }
        
        for (i, uid) in utiwakeids.enumerated(){
            queryString = "UPDATE Himoku SET Namae= '" + (himokuNamae + "/" + utiwakeNamaes[i]) + "' WHERE Id=" + String(uid)
            
            if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
                let errmsg = String(cString: sqlite3_errmsg(db)!)
                someMessageWithAlert("error prepare update utiwake namae Of updated Himoku: \(errmsg)" , "stop the app")
                return false
            }
            
            //execute the query to insert values
            if sqlite3_step(stmt) != SQLITE_DONE {
                let errmsg = String(cString: sqlite3_errmsg(db)!)
                someMessageWithAlert("failure updating utiwake namae Of updated Himoku: \(errmsg)")
                return false
            }
        }
        
        sqlite3_finalize(stmt)
        guard readFromHimokuTable() else{return false}
        return readFromItemsTable(theSisanNo)
    }
    
    func updateNamaeOfUtiwakeHimoku(id:Int, namae:String)->Bool{
        let queryString = "UPDATE Himoku SET Namae= '" + namae + "' WHERE Id=" + String(id)
        
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update Namae Of Utiwake Himoku: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating Namae Of Utiwake Himoku: \(errmsg)")
            return false
        }
        guard readFromHimokuTable() else{return false}
        return readFromItemsTable(theSisanNo)
    }
    
    func deleteUtiwakeHimoku(id:Int, hno:Int, ucount:Int)->Bool{
        //delete ----------------------
        var queryString = "DELETE FROM Himoku WHERE Id=" + String(id)
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing delete utiwake: \(errmsg)")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure delet from himoku: \(errmsg)")
            return false
        }
        
        //update himoku:
        queryString = "UPDATE Himoku SET Ucount= " + String(ucount - 1) + " WHERE Id=" + String(hno)
        
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update Ucount Of Himoku: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating Ucount Of Himoku: \(errmsg)")
            return false
        }
        
        // delete items where HimokuNo = deleted himoku id
        queryString = "DELETE FROM Items WHERE HimokuNo=" + String(id)
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing delete items from utiwake: \(errmsg)")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure delete items  from himoku: \(errmsg)")
            return false
        }
        sqlite3_finalize(stmt)
        guard readFromHimokuTable() else{return false}
        guard readFromItemsTable(theSisanNo)else{return false}
        return readFromSisanTable()
    }
    
    func deleteHimokuHimoku(himokuid:Int, utiwakeids:[Int])->Bool{
        //delete himokuand utiwake ----------------------
        var queryString = "DELETE FROM Himoku WHERE Hno=" + String(himokuid)
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing delete himoku,utiwake: \(errmsg)")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure delete from himoku,utiwake: \(errmsg)")
            return false
        }
        
        //delete items where HimokuNo = utiwakeids[]
        for id in utiwakeids{
            queryString = "DELETE FROM Items WHERE HimokuNo=" + String(id)
            //preparing the query
            if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
                let errmsg = String(cString: sqlite3_errmsg(db)!)
                someMessageWithAlert("error preparing delete items from himoku delete: \(errmsg)")
                return false
            }
            
            //execute the query to insert values
            if sqlite3_step(stmt) != SQLITE_DONE {
                let errmsg = String(cString: sqlite3_errmsg(db)!)
                someMessageWithAlert("failure delet  items from himoku delete: \(errmsg)")
                return false
            }

        }
        
        sqlite3_finalize(stmt)
        guard readFromHimokuTable() else{return false}
        guard readFromItemsTable(theSisanNo)else{return false}
        return readFromSisanTable()
    }
    //------------------------------------------ for himoku table
    
    func readFromItem1Item(_ itemId:Int) -> Items? {
        let item1Data = Items(Id: -1, Hizuke: "", Nen: 0, Tuki: 0, Hi: 0, SisanNo: 0, SyubetuNo: 0, HimokuNo: 0, IdouSisanNo: 0, IdouId: 0, Nyuukin: 0, Syukkin: 0, Bikou: "", strHimoku: "", strNyuukin: "", strSyukkin: "", Zankin: 0)
        //this is our seleted query
        let queryString = "SELECT * FROM Items WHERE Id = " + String(itemId)
        
        //statement pointer
        //var stmt: OpaquePointer?
        
        //prepare the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare selct from item: \(errmsg)" , "stop the app")
            return nil
        }
        
        if (sqlite3_step(stmt) == SQLITE_ROW) {
            item1Data.Id = Int(sqlite3_column_int(stmt, 0))
            item1Data.Hizuke = String(cString: sqlite3_column_text(stmt, 1))
            item1Data.Nen = Int(sqlite3_column_int(stmt, 2))
            item1Data.Tuki = Int(sqlite3_column_int(stmt, 3))
            item1Data.Hi = Int(sqlite3_column_int(stmt, 4))
            item1Data.SisanNo = Int(sqlite3_column_int(stmt, 5))
            item1Data.SyubetuNo = Int(sqlite3_column_int(stmt, 6))
            item1Data.HimokuNo = Int(sqlite3_column_int(stmt, 7))
            item1Data.IdouSisanNo = Int(sqlite3_column_int(stmt, 8))
            item1Data.IdouId = Int(sqlite3_column_int(stmt, 9))
            item1Data.Nyuukin = Int(sqlite3_column_int(stmt, 10))
            item1Data.Syukkin = Int(sqlite3_column_int(stmt, 11))
            item1Data.Bikou = String(cString: sqlite3_column_text(stmt, 12))
            item1Data.strHimoku = getHimokuNamaeFromHimokuRowNo(item1Data.SyubetuNo, item1Data.HimokuNo!, item1Data.IdouSisanNo!)
        }else{
            return nil
        }
        
        sqlite3_finalize(stmt)
        return item1Data
    
    }
    
    func readFromItemsTable(_ sisanId:Int) -> Bool {
        
        //let sisanId = sisanList[theSisanNo].Id
        itemList.removeAll()
        var zankin = sisanList[theSisanNo].SyokiKingaku
        
        itemId2Idx.removeAll(); itemIdx2Id.removeAll()
        
        //this is our seleted query
        let queryString = "SELECT * FROM Items WHERE SisanNo = " + String(sisanId) + " ORDER BY Hizuke"
        
        //statement pointer
        //var stmt: OpaquePointer?
        
        //prepare the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare selct from item: \(errmsg)" , "stop the app")
            return false
        }
        
        //traversing through all records
        
        
        let formatter = NumberFormatter()
        formatter.numberStyle = NumberFormatter.Style.decimal
        formatter.groupingSeparator = ","
        formatter.groupingSize = 3
        
        var idx = -1
        while (sqlite3_step(stmt) == SQLITE_ROW) {
            let Id = sqlite3_column_int(stmt, 0)
            let Hizuke = String(cString: sqlite3_column_text(stmt, 1))
            let Nen = sqlite3_column_int(stmt, 2)
            let Tuki = sqlite3_column_int(stmt, 3)
            let Hi = sqlite3_column_int(stmt, 4)
            let SisanNo = sqlite3_column_int(stmt, 5)
            let SyubetuNo = sqlite3_column_int(stmt, 6)
            let HimokuNo = sqlite3_column_int(stmt, 7)
            let IdouSisanNo = sqlite3_column_int(stmt, 8)
            let IdouId = sqlite3_column_int(stmt, 9)
            let Nyuukin = sqlite3_column_int(stmt, 10)
            let Syukkin = sqlite3_column_int(stmt, 11)
            let Bikou = String(cString: sqlite3_column_text(stmt, 12))
            var strNyuukin = "" ; var strSyukkin = ""
            switch SyubetuNo{
            case 1,3: //支出、移動支出
                
                strSyukkin = formatter.string(from: NSNumber(value: Syukkin))!
                zankin -= Int(Syukkin)
            case 2,4://
                strNyuukin = formatter.string(from: NSNumber(value: Nyuukin))!
                zankin += Int(Nyuukin)
            default:
                someMessageWithAlert("error in readFromItemTable IntToStr")
            }
            //zankin = zankin + Int(Nyuukin) - Int(Syukkin)
            //adding values to list
            itemList.append(Items(Id: Int(Id), Hizuke: String(describing: Hizuke), Nen: Int(Nen) , Tuki: Int(Tuki), Hi: Int(Hi), SisanNo: Int(SisanNo), SyubetuNo: Int(SyubetuNo), HimokuNo: Int(HimokuNo), IdouSisanNo: Int(IdouSisanNo), IdouId: Int(IdouId), Nyuukin: Int(Nyuukin), Syukkin: Int(Syukkin), Bikou: String(describing: Bikou), strHimoku:  getHimokuNamaeFromHimokuRowNo(Int(SyubetuNo), Int(HimokuNo), Int(IdouSisanNo)), strNyuukin: String(describing: strNyuukin), strSyukkin: String(describing: strSyukkin), Zankin:zankin)  )
            idx += 1
            itemId2Idx[Int(Id)] = idx; itemIdx2Id[idx] = Int(Id)
        }
        sqlite3_finalize(stmt)
        updateSisanZankinList(sisanId, zankin)
        return true
    }
    
    func getHimokuNamaeFromHimokuRowNo(_ SyubetuNo:Int, _ HimokuNo:Int, _ IdouSisanNo:Int) -> String{
        
        switch SyubetuNo{
            case 1,2://支出または収入
                return getHimokuNamaeFromNo(HimokuNo)
            case 3,4://移動支出、移動収入
                return getSisanNamaeFromNo(IdouSisanNo)
            default:
                return "????"
        }
    }
    
    func getHimokuNamaeFromNo(_ no:Int) -> String{
        for h in himokuList{
            if h.Id == no{
                return h.Namae
            }
        }
        return "????"
    }
    
    func getSisanNamaeFromNo(_ no:Int) -> String{
        for s in sisanList{
            if s.Id == no{
                return s.Namae
            }
        }
        return "????"
    }
    
    

    
    //binding the parameters
    func bind_text(_ col:Int, _ txt:String) -> Bool {
        let u8txt = (txt as NSString).utf8String
        if sqlite3_bind_text(stmt, Int32(col), u8txt, -1, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure binding text: \(errmsg)")
            return false
        }
        return true
    }
    
    func bind_int(_ col:Int, _ i:Int) -> Bool{
        if sqlite3_bind_int(stmt, Int32(col), Int32(i)) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure binding int: \(errmsg)")
            return false
        }
        return true
    }
    
    func itemNyuukinSyukkinInsert(_ hizuke:String, _ yy:Int, _ mm:Int, _ dd:Int,_ sisanNo:Int,_ syubetuNo:Int, _ HimokuNo:Int,  _ kingaku:Int, _ bikou:String) -> Bool {
        
        //statement pointer
        //var stmt: OpaquePointer?
        
        
        //the insert quary
        var queryString = "INSERT INTO Items (Hizuke,Nen,Tuki,Hi,SisanNo,SyubetuNo,HimokuNo,IdouId"
        if syubetuNo == 1{
            queryString += ",Syukkin,Bikou) VALUES (?,?,?,?,?,?,?,?,?,?)"
        }else{
            queryString += ",Nyuukin,Bikou) VALUES (?,?,?,?,?,?,?,?,?,?)"
        }
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing Syukkin,Nyuukin insert: \(errmsg)")
            return false
        }
    
        
        guard bind_text(1, hizuke)else{someMessageWithAlert("error insert Column Hizuke"); return false}
        guard bind_int(2, yy) else{someMessageWithAlert("error insert Column  Nen"); return false}
        guard bind_int(3, mm) else{someMessageWithAlert("error insert Column  Tuki"); return false}
        guard bind_int(4, dd) else{someMessageWithAlert("error insert Column Hi "); return false}
        guard bind_int(5, sisanNo)else{someMessageWithAlert("error insert Column SisanNo ");return false}
        guard bind_int(6, syubetuNo)else{someMessageWithAlert("error insert Column SyubetuNo ");return false}
        guard bind_int(7, HimokuNo)else{someMessageWithAlert("error insert Column HimokuNo "); return false}
        guard bind_int(8, -1) else{ // set IdouId = -1
            someMessageWithAlert("error insert Column IdouId "); return false}
        guard bind_int(9, kingaku) else{someMessageWithAlert("error insert Column Syukkin "); return false}
        guard bind_text(10, bikou) else{someMessageWithAlert("error insert Column Bikou "); return false}

        
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting item Syukkin,Nyuukin: \(errmsg)")
            return false
        }
        
        sqlite3_finalize(stmt)
        
        guard readFromItemsTable(sisanList[theSisanNo].Id) else{return false}
        
        return true
    }

    func itemIdouSisanInsert(_ hizuke:String,_ yy:Int, _ mm:Int, _ dd:Int,_ sisanId:Int,_ syubetuNo:Int, _ IdouSisanId:Int,  _ kingaku:Int, _ bikou:String) -> Bool {
        
        //移動元データ挿入、移動柵データ挿入、　移動元データ更新
        

        // 移動元データの挿入-------
        //the insert quary
        let queryString3 = "INSERT INTO Items (Hizuke,Nen,Tuki,Hi,SisanNo,SyubetuNo,IdousisanNo,IdouId,Syukkin,Bikou) VALUES (?,?,?,?,?,?,?,?,?,?)"
        //preparing the query
        if sqlite3_prepare(db, queryString3, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing 移動元データ insert: \(errmsg)")
            return false
        }
        guard bind_text(1, hizuke)else{someMessageWithAlert("error insert Column Hizuke"); return false}
        guard bind_int(2, yy) else{someMessageWithAlert("error insert Column  Nen"); return false}
        guard bind_int(3, mm) else{someMessageWithAlert("error insert Column  Tuki"); return false}
        guard bind_int(4, dd) else{someMessageWithAlert("error insert Column Hi "); return false}
        guard bind_int(5, sisanId)else{someMessageWithAlert("error insert Column SisanNo ");return false}
        guard bind_int(6, syubetuNo)else{someMessageWithAlert("error insert Column SyubetuNo ");return false}
        guard bind_int(7, IdouSisanId)else{someMessageWithAlert("error insert Column HimokuNo "); return false}
        guard bind_int(8, -1) else{ // set IdouId = -1 temporaly, after next insert ,set last_insert_rowid
            someMessageWithAlert("error insert Column IdouId "); return false}
        guard bind_int(9, kingaku) else{someMessageWithAlert("error insert Column Syukkin "); return false}
        guard bind_text(10, bikou) else{someMessageWithAlert("error insert Column Bikou "); return false}
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting item Syukkin,Nyuukin: \(errmsg)")
            return false
        }
        
        let rowId3 = Int(sqlite3_last_insert_rowid(db))
        
        sqlite3_finalize(stmt)

        
        //移動先データの挿入------
        let queryString4 = "INSERT INTO Items (Hizuke,Nen,Tuki,Hi,SisanNo,SyubetuNo,IdousisanNo,IdouId,Nyuukin,Bikou) VALUES (?,?,?,?,?,?,?,?,?,?)"
        //preparing the query
        if sqlite3_prepare(db, queryString4, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing 移動先データ insert: \(errmsg)")
            return false
        }
        guard bind_text(1, hizuke)else{someMessageWithAlert("error insert Column Hizuke"); return false}
        guard bind_int(2, yy) else{someMessageWithAlert("error insert Column  Nen"); return false}
        guard bind_int(3, mm) else{someMessageWithAlert("error insert Column  Tuki"); return false}
        guard bind_int(4, dd) else{someMessageWithAlert("error insert Column Hi "); return false}
        guard bind_int(5, IdouSisanId)else{someMessageWithAlert("error insert Column SisanNo ");return false}
        guard bind_int(6, 4)else{someMessageWithAlert("error insert Column SyubetuNo ");return false}
        guard bind_int(7, sisanId)else{someMessageWithAlert("error insert Column HimokuNo "); return false}
        guard bind_int(8, Int(rowId3)) else{ //  last_insert_rowid
            someMessageWithAlert("error insert Column IdouId "); return false}
        guard bind_int(9, kingaku) else{someMessageWithAlert("error insert Column Syukkin "); return false}
        guard bind_text(10, bikou) else{someMessageWithAlert("error insert Column Bikou "); return false}
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure inserting item Syukkin,Nyuukin: \(errmsg)")
            return false
        }
        let rowId4 = Int(sqlite3_last_insert_rowid(db))
        
        sqlite3_finalize(stmt)
        
        guard readFromItemsTable(IdouSisanId) else{return false}
        
        //update 移動元データ-------
        let queryString = "UPDATE Items SET IdouId=" + String(rowId4) + " WHERE Id=" + String(rowId3)
        
        //prepare the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update 移動元item: \(errmsg)" , "stop the app")
            return false
        }
            
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating  移動元item: \(errmsg)")
            return false
        }

        sqlite3_finalize(stmt)
        
        guard readFromItemsTable(sisanId) else{return false}
        
        return true

        
    }
    
    func itemDelete(_ id:Int)->Bool{
        
        //the delete quary
        let queryString = "DELETE FROM Items WHERE Id=" + String(id)
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing delete: \(errmsg)")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure deletin from Items: \(errmsg)")
            return false
        }
        sqlite3_finalize(stmt)
        return readFromItemsTable(sisanList[theSisanNo].Id)
        
    }
    
    func itemDeleteWhereSisanNo(_ sisanNo:Int) -> Bool{
        //the delete quary
        let queryString = "DELETE FROM Items WHERE (SisanNo=" + String(sisanNo) + " ) OR ( (IdouSisanNo IS NOT NULL) AND (IdousisanNo = " + String(sisanNo) + ") )"
        
        //preparing the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK{
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error preparing delete: \(errmsg)")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure delete where sisanId= from Items: \(errmsg)")
            return false
        }
        sqlite3_finalize(stmt)
        return readFromItemsTable(sisanList[theSisanNo].Id)

    }
    
    func itemUpdate(_ id:Int, _ hizuke:String,_ yy:Int, _ mm:Int, _ dd:Int,_ sisanId:Int,_ syubetuNo:Int, _ himokuno:Int,  _ kingaku:Int, _ bikou:String) -> Bool {

        var queryString = "UPDATE Items SET"
        switch syubetuNo {
        case 1:// 支出
            queryString += " Hizuke= '" + hizuke +  "' ,Nen=" + String(yy) + " ,Tuki=" + String(mm) + " ,Hi=" + String(dd) + " ,SisanNo=" + String(sisanId) + " ,SyubetuNo=" + String(syubetuNo) + " ,HimokuNo=  " + String(himokuno) + " ,Syukkin=" + String(kingaku) + " ,Bikou = '" + bikou + "'"
        case 2:// 収入
            queryString += " Hizuke= '" + hizuke +  "' ,Nen=" + String(yy) + " ,Tuki=" + String(mm) + " ,Hi=" + String(dd) + " ,SisanNo=" + String(sisanId) + " ,SyubetuNo=" + String(syubetuNo) + " ,HimokuNo=  " + String(himokuno) + " ,Nyuukin=" + String(kingaku) + " ,Bikou = '" + bikou + "'"
        default:// 3,4 移動データ　、この処理はまだ実装されてない
            return false
        }
 
        queryString += " WHERE Id=" + String(id)
        
        //prepare the query
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare update 編集更新item: \(errmsg)" , "stop the app")
            return false
        }
        
        //execute the query to insert values
        if sqlite3_step(stmt) != SQLITE_DONE {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("failure updating  編集更新item: \(errmsg)")
            return false
        }
        
        sqlite3_finalize(stmt)
        
        guard readFromItemsTable(sisanId) else{return false}
        return true
    }

    
    //for reporting
    func readYearsFromItemsTable()->Bool{
        
        let queryString = "SELECT DISTINCT Nen FROM Items ORDER BY Nen"
        if sqlite3_prepare(db, queryString, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare select distinct nen from item: \(errmsg)" , "stop the app")
            return false
        }
        yearsList.removeAll()
        while (sqlite3_step(stmt) == SQLITE_ROW){
            let n = sqlite3_column_int(stmt, 0)
            yearsList.append(String(n))
        }
        sqlite3_finalize(stmt)
        return true
    }
    
    func annualInOutFromItemsTable(nen:String)->Bool{
        
        let NoIncome = "2"; let NoSpending = "1"
        
        var q0 = "Select Himoku.Namae "
        for month in 1...12{
            q0 += " , SUM(CASE WHEN Tuki = " + String(month) + " THEN Nyuukin END) AS g" + String(month)
        }
        q0 += ",SUM(CASE WHEN Nen=" + nen + " THEN Nyuukin END) AS N" + nen + "  FROM Items JOIN Himoku ON Items.HimokuNo=Himoku.Id WHERE Nen=" + nen + " AND Items.SyubetuNo=" + NoIncome + " GROUP BY Items.HimokuNo"
        
        
        if sqlite3_prepare(db, q0, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare select annual income of nen from item: \(errmsg)" , "stop the app")
            return false
        }
        annualInNameList.removeAll(); annualInDataList.removeAll()
        var aData = [Int]()
        while (sqlite3_step(stmt) == SQLITE_ROW){
            annualInNameList.append(String(cString: sqlite3_column_text(stmt, 0)))
            for i in 1...13{
                aData.append(Int(sqlite3_column_int(stmt, Int32(i))))
            }
            annualInDataList.append(aData)
            aData.removeAll()
        }
        sqlite3_finalize(stmt)
        
        var q1 = "Select Himoku.Namae "
        for month in 1...12{
            q1 += " , SUM(CASE WHEN Tuki = " + String(month) + " THEN Syukkin END) AS g" + String(month)
        }
        q1 += ",SUM(CASE WHEN Nen=" + nen + " THEN Syukkin END) AS N" + nen + "  FROM Items JOIN Himoku ON Items.HimokuNo=Himoku.Id WHERE Nen=" + nen + " AND Items.SyubetuNo=" + NoSpending + " GROUP BY Items.HimokuNo"
        
        if sqlite3_prepare(db, q1, -1, &stmt, nil) != SQLITE_OK {
            let errmsg = String(cString: sqlite3_errmsg(db)!)
            someMessageWithAlert("error prepare select annual spending of nen from item: \(errmsg)" , "stop the app")
            return false
        }
        annualOutNameList.removeAll(); annualOutDataList.removeAll()
        aData.removeAll()
        while (sqlite3_step(stmt) == SQLITE_ROW){
            annualOutNameList.append(String(cString: sqlite3_column_text(stmt, 0)))
            for i in 1...13{
                aData.append(Int(sqlite3_column_int(stmt, Int32(i))))
            }
            
            annualOutDataList.append(aData)
            aData.removeAll()
        }
        sqlite3_finalize(stmt)
        
        annualTotalDataList.removeAll()
        for _ in 1...3{
            annualTotalDataList.append([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0])
        }
        for row in annualInDataList{
            for (month, data) in row.enumerated(){
                annualTotalDataList[0][month] += data
            }
        }
        for row in annualOutDataList{
            for (month, data) in row.enumerated(){
                annualTotalDataList[1][month] += data
            }
        }
        for month in 0...12{
            annualTotalDataList[2][month] = annualTotalDataList[0][month] - annualTotalDataList[1][month]
        }

        return true
    }
    //-----------------------------------------------------------------------reporting
    
    func someMessageWithAlert(_ message: String, _ textInfo:String = "information") {
        let alert = NSAlert()
        alert.messageText = message
        alert.informativeText = textInfo
        alert.runModal()
    }
}//------------------------------------
