//
//  PrefsSisanViewController.swift
//  sKakeibo
//
//  Created by 梅山 新一郎 on 2018/08/12.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa

class PrefsSisanViewController: NSViewController, NSTableViewDataSource, NSTableViewDelegate {
    
    let DM = DataModel.sharedInstance
    
    var sisanKoumokuSyoriNo = -1 // 1:新規追加、2：編集更新、 3:削除、 -1:なし
    var sisanKoumokuChangedSw = false
    
    override func viewWillAppear() {

        //self.view.window?.titleVisibility = .hidden
        //self.view.window?.titlebarAppearsTransparent = true
        //self.view.window?.styleMask.insert(.fullSizeContentView)
        self.view.window?.styleMask.remove(.closable)
        self.view.window?.styleMask.remove(.fullScreen)
        self.view.window?.styleMask.remove(.miniaturizable)
        self.view.window?.styleMask.remove(.resizable)

        //self.view.window?.isMovable = false
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        tblSisanKoumoku.delegate = self
        tblSisanKoumoku.dataSource = self
        
        sisanKoumokuBox.isHidden = true
        
    }
    
    var delegate: AnyObject?
    
    override func viewWillDisappear() {
        (delegate as! ViewController).sisanKoumokuChanged(
            sisanKoumokuChangedSw)
    }
    
  
    
    @IBAction func btnSisanModalClose(_ sender: Any) {
        
        dismiss(self)
    }
    
    @IBOutlet weak var sisanKoumokuBox: NSBox!
    
    
    @IBOutlet weak var txtSisanKoumokuNamae: NSTextField!
    
    @IBOutlet weak var txtSisanKoumokuSyokikingaku: NSTextField!
    
    @IBOutlet weak var btnSisanKoumokuOKTitle: NSButton!
    
    @IBOutlet weak var btnSisanKoumokuCancelTitle: NSButton!
    

    @IBAction func btnSisanKoumokuTuika(_ sender: Any) {
        
        sisanKoumokuBox.isHidden = false
        sisanKoumokuSyoriNo = 1
        sisanKoumokuBox.title = "新規追加"
        btnSisanKoumokuOKTitle.title = "この新規追加の実行"
        btnSisanKoumokuCancelTitle.title = "この新規追加取消"
        
    }
    
    @IBAction func btnSisanKoumokuKousin(_ sender: Any) {
        guard tblSisanKoumoku.selectedRow != -1
            else{
                someMessageWithAlert("編集更新する資産の行データを選択してからにしてください。")
                return
        }
        sisanKoumokuBox.isHidden = false
        sisanKoumokuSyoriNo = 2
        sisanKoumokuBox.title = "編集更新"
        btnSisanKoumokuOKTitle.title = "この編集更新の実行"
        btnSisanKoumokuCancelTitle.title = "この編集更新取消"
        
        let d = DM.sisanList[tblSisanKoumoku.selectedRow]
        txtSisanKoumokuNamae.stringValue = d.Namae
        txtSisanKoumokuSyokikingaku.integerValue = d.SyokiKingaku
    }
    
    @IBAction func btnSisanKoumokuSakujyo(_ sender: Any) {
        guard tblSisanKoumoku.selectedRow != -1
            else{
                someMessageWithAlert("削除する資産の行データを選択してからにしてください。")
                return
        }
        sisanKoumokuBox.isHidden = false
        sisanKoumokuSyoriNo = 3
        sisanKoumokuBox.title = "削除"
        btnSisanKoumokuOKTitle.title = "この削除の実行"
        btnSisanKoumokuCancelTitle.title = "この削除 取消"
        let d = DM.sisanList[tblSisanKoumoku.selectedRow]
        txtSisanKoumokuNamae.stringValue = d.Namae
        txtSisanKoumokuSyokikingaku.integerValue = d.SyokiKingaku
    }


    @IBAction func btnSisanKoumokuOK(_ sender: Any) {
        
        let fldKingakuS = txtSisanKoumokuSyokikingaku.stringValue.trimmingCharacters(in: .whitespacesAndNewlines)
        let fldKingaku = fldKingakuS.replacingOccurrences(of: ",", with: "")
        if (fldKingaku.isEmpty || !isStringContainsOnlyNumbers(string: fldKingaku)){
            txtSisanKoumokuSyokikingaku.wantsLayer = true
            txtSisanKoumokuSyokikingaku.layer?.borderWidth  = 2.0
            txtSisanKoumokuSyokikingaku.layer?.borderColor = NSColor.red.cgColor
            someMessageWithAlert("金額の欄に不正なデータがあります")
            return
        }
        
        switch sisanKoumokuSyoriNo {
        case 1:
            guard DM.sisanInsert(txtSisanKoumokuNamae.stringValue, Int(fldKingaku)!) else {return}
            txtSisanKoumokuNamae.stringValue = ""
            txtSisanKoumokuSyokikingaku.stringValue = ""
        case 2:
            let id = DM.sisanList[tblSisanKoumoku.selectedRow].Id
            guard DM.sisanUpdate(id, txtSisanKoumokuNamae.stringValue, Int(fldKingaku)!, Int(fldKingaku)!) else{return}
            tblSisanKoumoku.deselectRow(tblSisanKoumoku.selectedRow)
        case 3:
            guard yesNoMessageWithAlert("この資産での支出／収入のデータも削除されます。\n 削除してもいいですか？", "削除する", "しない") else{
                sisanKoumokuBox.isHidden = true
                return
            }
            let d = DM.sisanList[tblSisanKoumoku.selectedRow]
            guard DM.itemDeleteWhereSisanNo(d.Id) else{return}
            guard DM.sisanDelete(d.Id) else{return}
             tblSisanKoumoku.deselectRow(tblSisanKoumoku.selectedRow)
            DM.theSisanNo = 0

        default:
            return
        }
        
        sisanKoumokuChangedSw = true
        tblSisanKoumoku.reloadData()
        
        sisanKoumokuBox.isHidden = true
    }
    
    @IBAction func btnSisanKoumokuCancel(_ sender: Any) {
        sisanKoumokuSyoriNo = -1
        tblSisanKoumoku.deselectRow(tblSisanKoumoku.selectedRow)

        
        sisanKoumokuBox.isHidden = true
    }

    
    
    
    
    
    
    // tableView-------------------------
    @IBOutlet weak var tblSisanKoumoku: NSTableView!
    
    func numberOfRows(in tableView: NSTableView) -> Int {
        return DM.sisanList.count
    }
    
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        
        switch tableColumn!.identifier.rawValue {
        case "sisanMeisyou":
            vw.textField?.stringValue = DM.sisanList[row].Namae
        case "sisanSyokikingaku":
            vw.textField?.integerValue = DM.sisanList[row].SyokiKingaku
            
        default:
            return nil
        }
        return vw
    }
    
    //--------------------------tableView
    
    func isStringContainsOnlyNumbers(string: String) -> Bool {
        return string.trimmingCharacters(in: .decimalDigits).count <= 0
    }
    func someMessageWithAlert(_ message: String, _ textInfo:String = "information") {
        let alert = NSAlert()
        alert.messageText = message
        alert.informativeText = textInfo
        alert.runModal()
    }
    func yesNoMessageWithAlert(_ message:String, _ yesTitle:String, _ noTitle:String) -> Bool{
        //Yes: return true, No:return false
        let alert = NSAlert()
        alert.messageText = message
        alert.addButton(withTitle: yesTitle)// = 1000
        alert.addButton(withTitle: noTitle)   // = 1001
        if alert.runModal().rawValue == 1000{
            return true
        }else{
            return false
        }
        
    }
    
}
