//
//  SisanReportViewController.swift
//  sKakeibo
//
//  Created by 梅山 新一郎 on 2018/10/27.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa
import Quartz

class SisanReportViewController: NSViewController,NSTableViewDataSource, NSTableViewDelegate {

    let DM = DataModel.sharedInstance
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        tblReportSisan.dataSource = self
        tblReportSisan.delegate = self
        
        lblTotal.integerValue = DM.GrandTotalSisan
    }
    
    
    
    @IBAction func btnSisanPDF(_ sender: Any) {
        let aPdfDoc = PDFDocument()
        let numberOfDatasRowsPerPage = 20
        var numberOfPages = DM.sisanList.count / numberOfDatasRowsPerPage
        if DM.sisanList.count % numberOfDatasRowsPerPage > 0{
            numberOfPages += 1
        }
        
        for i in 0 ..< numberOfPages{
            let startIndex = i * numberOfDatasRowsPerPage
            var endIndex = i * numberOfDatasRowsPerPage + numberOfDatasRowsPerPage
            if endIndex >  DM.sisanList.count{
                endIndex = DM.sisanList.count
            }
            
            let pdfDataSisan:[Sisan] = Array(DM.sisanList[startIndex..<endIndex])
            let aPage = SisanReportPDFPage(sisanData:pdfDataSisan, total:DM.GrandTotalSisan)
            aPdfDoc.insert(aPage, at: i)
            
        }
        
        let FS = NSSavePanel()
        FS.canCreateDirectories = true
        FS.allowedFileTypes = ["pdf", "PDF"]
        if FS.runModal() == NSApplication.ModalResponse.OK{
            let fileURL = FS.url
            let strFS = (fileURL?.path)!
            aPdfDoc.write(toFile: strFS)
        }
        //aPdfDoc.write(toFile: "/Users/umeya/Desktop/temp/aPrjCreatePDF.pdf")
    }
    
    @IBAction func btnSisanCSV(_ sender: Any) {
        let DF = DateFormatter()
        DF.dateFormat = "YYYY年MM月dd日"
        DF.timeZone = NSTimeZone.local
        var fileStrData:String = "資産レポート ,　" + DF.string(from: Date()) + "\n"
        fileStrData += "名 称 , 金　額 \n"
        
        let FS = NSSavePanel()
        FS.canCreateDirectories = true
        FS.allowedFileTypes = ["csv", "CSV"]
        if FS.runModal() == NSApplication.ModalResponse.OK{
            let fileURL = FS.url
            let strFS = (fileURL?.path)!
            for line in DM.sisanList{
                fileStrData += line.Namae + "," + String(line.Zankin) + " \n"
            }
            fileStrData += "合計 , " + String(DM.GrandTotalSisan) + " \n"
            do{
                try fileStrData.write(toFile: strFS, atomically: true, encoding: String.Encoding.utf8)
            }catch let error as NSError{
                print("sisan report csv write error \n\(error)")
            }
        }
    }
    
    @IBOutlet weak var lblTotal: NSTextField!
    
    @IBOutlet weak var tblReportSisan: NSTableView!
    
    func numberOfRows(in tableView: NSTableView) -> Int {
        return DM.sisanList.count
    }
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        switch tableColumn!.identifier.rawValue {
        case "sisanNamae":
            vw.textField?.stringValue = DM.sisanList[row].Namae
        case "sisanZankin":
            vw.textField?.integerValue = DM.sisanList[row].Zankin
            
        default:
            return nil
        }
        return vw
    }
}
