let DM = DataModel.sharedInstance//
//  ViewController.swift
//  sKakeibo
//
//  Created by 梅山 新一郎 on 2018/07/22.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa

class ViewController: NSViewController,NSTableViewDataSource, NSTableViewDelegate, NSComboBoxDataSource, NSComboBoxDelegate {

    
    let DM = DataModel.sharedInstance
    
    fileprivate var theItemDataSelectedId = -1
    
    @IBOutlet var lblSisanmei: NSTextField!
    
    @IBOutlet var lblToday: NSTextField!
    
    @IBOutlet var lblSisanSouGoukei: NSTextField!
    
    @IBOutlet var tblSisan: NSTableView!
    
    @IBOutlet var tblItem: NSTableView!
    
    @IBOutlet weak var itemData: NSBox!
    
   
    var cmbItemDataIdArray = [Int]()
    var cmbItemDataNamae = [String]()
    
    
    
    override func viewDidLoad() {
        super.viewDidLoad()

        tblSisan.dataSource = self
        tblSisan.delegate = self
        tblItem.dataSource = self
        tblItem.delegate = self
        
        
        
        cmbItemDataHimomku.usesDataSource = true
        cmbItemDataHimomku.dataSource = self
        cmbItemDataHimomku.delegate = self
        
        lblSisanSouGoukei.integerValue = DM.GrandTotalSisan
        
        let DF = DateFormatter()
        DF.dateFormat = "YYYY年MM月dd日"
        DF.timeZone = NSTimeZone.local
        lblToday.stringValue = DF.string(from: Date())
        
        tblSisan.selectRowIndexes(NSIndexSet(index: 0) as IndexSet, byExtendingSelection: false)
        lblSisanmei.stringValue = DM.sisanList[0].Namae
        
        itemDataDatePicker.locale = Locale(identifier: "ja_JP")
        itemDataDatePicker.dateValue = Date()
        
        rdbSisyutu.state = NSControl.StateValue.on
        rdbtnSelected(rdbSisyutu)

        itemData.isHidden = true
        
    }

    override var representedObject: Any? {
        didSet {
        // Update the view, if already loaded.
        }
    }

    
    
    // tableView -----------------------------------------
    
    func numberOfRows(in tableView: NSTableView) -> Int {
        if tableView.tag == 0{ // tblSisan
            return DM.sisanList.count
        } else {                // ytblItem
            return DM.itemList.count
        }
    }
    
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        
        if tableView.tag == 0 { // tblSisan
            
            switch tableColumn!.identifier.rawValue {
            case "sisanNamae":
                vw.textField?.stringValue = DM.sisanList[row].Namae
            case "sisanZankin":
                vw.textField?.integerValue = DM.sisanList[row].Zankin
                
            default:
                return nil
            }
            
        } else{

            switch tableColumn!.identifier.rawValue {
            case "itemHizuke":
                vw.textField?.stringValue = DM.itemList[row].Hizuke
            case "itemHimoku":
                vw.textField?.stringValue = DM.itemList[row].strHimoku
            case "itemNyuukin":
                    vw.textField?.stringValue = DM.itemList[row].strNyuukin
            case "itemSyukkin":
                    vw.textField?.stringValue = DM.itemList[row].strSyukkin
            case "itemZandaka":
                vw.textField?.integerValue = DM.itemList[row].Zankin
                
            default:
                    return nil
            }
            
            
        }
        return vw
    }
    
    func tableViewSelectionDidChange(_ notification: Notification) {
        guard let tvw = notification.object as? NSTableView else{return}
        guard tvw.selectedRow != -1 else {return}
        
        if tvw.tag == 0{           //on sisan tableView
            DM.theSisanNo = tvw.selectedRow
            lblSisanmei.stringValue = DM.sisanList[DM.theSisanNo].Namae
            guard  DM.readFromItemsTable(DM.sisanList[DM.theSisanNo].Id) else{return}
            tblItem.reloadData()
        } else if tvw.tag == 1{    //on item tableView
            theItemDataSelectedId = DM.itemList[tvw.selectedRow].Id
            return
        }
    }

    
    // -------------------------------------------------tableView
    
    
    
    //item insert,delete,edit ---------------------------
    
    fileprivate var theItemDataSyoriNo = 0
    // 1:新規追加、2:編集更新、3:削除
    
    @IBOutlet weak var cmbItemDataHimomku: NSComboBox!
    
    @IBOutlet weak var lblHimokuTitle: NSTextField!
    
    
    @IBOutlet weak var txtItemDataKingaku: NSTextField!
    
    @IBOutlet weak var txtItemDataBikou: NSTextField!
    
    @IBOutlet weak var itemDataSyubetu: NSBox!
    
    @IBOutlet weak var lblItemDataId: NSTextField!
    
    
    @IBOutlet weak var itemDataKingaku: NSTextField!
    
    @IBOutlet weak var itemDataBikou: NSTextField!
    
    @IBOutlet weak var itemDataDatePicker: NSDatePicker!
    
    
    @IBOutlet weak var rdbSisyutu: NSButton!
    @IBOutlet weak var rdbSyuunyuu: NSButton!
    @IBOutlet weak var rdbIdou: NSButton!
    
    
    
    
    @IBAction func rdbtnSelected(_ selectedRadioButton: NSButton) {
        
        
        setComboItemData(selectedRadioButton.tag + 1)
        
    }
    
    func setComboItemData(_ rbdNo:Int, _ idx:Int = -1){
        cmbItemDataNamae.removeAll(); cmbItemDataIdArray.removeAll()
        
        DM.theSyubetuNo = rbdNo
        
        switch  DM.theSyubetuNo{
        case 1,2: // 1:支出, 2:支出
            lblHimokuTitle.stringValue = "費目"
            for h in  DM.himokuList where h.SyubetuNo == DM.theSyubetuNo{
                if h.Ucount == 0{
                    cmbItemDataIdArray.append(h.Id)
                    cmbItemDataNamae.append(h.Namae)
                }
            }
        case 3: //移動
            lblHimokuTitle.stringValue = "移動先資産"
            for h in  DM.sisanList{
                cmbItemDataIdArray.append(h.Id)
                cmbItemDataNamae.append(h.Namae)
            }
        default:
            someMessageWithAlert("error rdbtnSelected")
            return
        }
        
        cmbItemDataHimomku.stringValue = ""
        cmbItemDataHimomku.reloadData()
    }
    // for  cmbItemDataHimoku-----------------------------------------
    func numberOfItems(in comboBox: NSComboBox) -> Int {
        guard case 1...4 = DM.theSyubetuNo else { return 0 }
        return cmbItemDataNamae.count
    }
    
    func comboBox(_ comboBox: NSComboBox, objectValueForItemAt index: Int) -> Any? {
        return cmbItemDataNamae[index]
    }
    
//    func comboBoxSelectionDidChange(_ notification: Notification) {
//        let theCmbSelectedRowNo = cmbItemDataHimomku.selectedTag()
//        DM.someMessageWithAlert("from comboBoxSekecteChange \(theCmbSelectedRowNo)")
//        print("comboBoxSelectionDidChange ")
//    }
    // ---------------------------------------for  cmbItemDataHimoku
    
    // responder chain to the responder object
    @IBAction func newItem(_ sender:AnyObject){
        itemData.isHidden = false
        itemDataSyubetu.title = "新規追加"
        theItemDataSyoriNo = 1
        rdbtnSelected(rdbSisyutu)
    }
    @IBAction func editUpdateItem(_ sender:AnyObject){
        
        
        let selRowNo = tblItem.selectedRow
        guard selRowNo != -1 else{
            someMessageWithAlert("データ行を選択してから編集してください。")
            return}
        let d = DM.itemList[selRowNo]
        guard  case 1...2 = d.SyubetuNo else{
             someMessageWithAlert("資産移動したデータは編集できません。必要なら、削除してから新規にデータを追加してください。")
            return
        }
        
        itemData.isHidden = false
        itemDataSyubetu.title = "編集更新"
        theItemDataSyoriNo = 2
        
        tblItem.isEnabled = false
        
        if d.SyubetuNo == 1{//支出
            rdbSisyutu.state = NSControl.StateValue.on
            rdbtnSelected(rdbSisyutu)
            //txtItemDataKingaku.integerValue = d.Syukkin!
            txtItemDataKingaku.stringValue = String(d.Syukkin!)
        }else{
            rdbSyuunyuu.state = NSControl.StateValue.on
            rdbtnSelected(rdbSyuunyuu)
            //txtItemDataKingaku.integerValue = d.Nyuukin!
            txtItemDataKingaku.stringValue = String(d.Nyuukin!)
        }
        
        guard let theCmbSelectedRowNo = comboBoxId2Idx(d.HimokuNo!) else{return}
        
        cmbItemDataHimomku.selectItem(at: theCmbSelectedRowNo)
        
        let df = DateFormatter()
        df.locale = Locale(identifier: "ja_JP")
        df.dateFormat = "yyyy-MM-dd"
        
        itemDataDatePicker.dateValue = df.date(from: d.Hizuke)!
        
        itemDataBikou.stringValue = d.Bikou!
        
    }
    
    func comboBoxId2Idx(_ searchId:Int)->Int?{
        for idx in 0 ..< cmbItemDataIdArray.count{
            if searchId == cmbItemDataIdArray[idx]{
                return idx
            }
        }
        return nil
    }
    @IBAction func deleteItem(_ sender:AnyObject){

        itemData.isHidden = true
        
        let selRowNo = tblItem.selectedRow
        guard selRowNo != -1 else{
            someMessageWithAlert("データ行を選択してから削除してください。")
            return}

        let d = DM.itemList[selRowNo]
        if case 3...4 = d.SyubetuNo{
            guard let d1 = DM.readFromItem1Item(d.IdouId!) else{return}
            var mes = "選択された行のデータと、"
            if d.SyubetuNo == 3{mes += "移動先:"}else{mes += "移動元:"}
            mes += DM.sisanList[DM.sisanId2Idx[d1.SisanNo]!].Namae
            guard yesNoMessageWithAlert(mes, "削除する", "しない")else{return}
            guard DM.itemDelete(d1.Id) else{return}
            guard DM.itemDelete(d.Id) else{return}
        }else{ //syubetuNo == 1 or 2
            guard yesNoMessageWithAlert("選択した行のデータを削除しますか？", "削除する", "しない")else{return}
            guard DM.itemDelete(d.Id) else{return}
            
        }
        tblItem.reloadData()
    }
    
    @IBAction func btnItemDataOK(_ sender: NSButton) {
        
        tblItem.isEnabled = true
        
        switch theItemDataSyoriNo {
        case 1:
            itemDataSinki()
        case 2:
            itemDataHensyuu()
        case 3:
            itemDataSakujyo()
        default:
            return
        }
        rdbSisyutu.state = NSControl.StateValue.on
        rdbtnSelected(rdbSisyutu)
        cmbItemDataHimomku.stringValue = ""
        txtItemDataKingaku.stringValue = ""
        txtItemDataBikou.stringValue = ""
        
    }
    
    func itemDataSinki(){
        if (DM.theSyubetuNo > 2) &&  (DM.sisanList[DM.theSisanNo].Id == cmbItemDataIdArray[cmbItemDataHimomku.indexOfSelectedItem]){
            someMessageWithAlert("移動元と移動先が同じです。処理を中止します。")
            return
        }
        let fldKingaku = txtItemDataKingaku.stringValue.trimmingCharacters(in: .whitespacesAndNewlines)
        if (fldKingaku.isEmpty || !isStringContainsOnlyNumbers(string: fldKingaku)){
            txtItemDataKingaku.wantsLayer = true
            txtItemDataKingaku.layer?.borderWidth  = 2.0
            txtItemDataKingaku.layer?.borderColor = NSColor.red.cgColor
            someMessageWithAlert("金額の欄に不正なデータがあります")
            return
        }
        
        let DF = DateFormatter()
        DF.dateFormat = "YYYY-MM-dd"
        DF.timeZone = NSTimeZone.local
        let YMD = DF.string(from: itemDataDatePicker.dateValue)
        let Y_M_D = YMD.split(separator: "-")
        let yy = Int(Y_M_D[0]);let mm = Int(Y_M_D[1]);let dd = Int(Y_M_D[2])
        
        switch DM.theSyubetuNo {
            case 1,2://支出、収入
                guard DM.itemNyuukinSyukkinInsert(YMD,yy!, mm!, dd!, DM.sisanList[DM.theSisanNo].Id, DM.theSyubetuNo, cmbItemDataIdArray[cmbItemDataHimomku.indexOfSelectedItem], Int(fldKingaku)!, txtItemDataBikou.stringValue) else {return}
        default://資産移動、３
            guard DM.itemIdouSisanInsert(YMD,yy!, mm!, dd!, DM.sisanList[DM.theSisanNo].Id, DM.theSyubetuNo, cmbItemDataIdArray[cmbItemDataHimomku.indexOfSelectedItem], Int(fldKingaku)!, txtItemDataBikou.stringValue) else {return}
        }
        
        tblItem.reloadData()
        tblSisan.reloadData()
        itemData.isHidden = true
        
        
    }
    
    func itemDataHensyuu(){
        let fldKingaku = txtItemDataKingaku.stringValue.trimmingCharacters(in: .whitespacesAndNewlines)
        
        if (fldKingaku.isEmpty || !isStringContainsOnlyNumbers(string: fldKingaku)){
            txtItemDataKingaku.wantsLayer = true
            txtItemDataKingaku.layer?.borderWidth  = 2.0
            txtItemDataKingaku.layer?.borderColor = NSColor.red.cgColor
            someMessageWithAlert("金額の欄に不正なデータがあります")
            return
        }
        
        let DF = DateFormatter()
        DF.dateFormat = "YYYY-MM-dd"
        DF.timeZone = NSTimeZone.local
        let YMD = DF.string(from: itemDataDatePicker.dateValue)
        let Y_M_D = YMD.split(separator: "-")
        let yy = Int(Y_M_D[0]);let mm = Int(Y_M_D[1]);let dd = Int(Y_M_D[2])
        
        guard DM.itemUpdate(theItemDataSelectedId, YMD,yy!, mm!, dd!, DM.sisanList[DM.theSisanNo].Id, DM.theSyubetuNo, cmbItemDataIdArray[cmbItemDataHimomku.indexOfSelectedItem], Int(fldKingaku)!, txtItemDataBikou.stringValue) else {return}
        
        tblItem.reloadData()
        tblSisan.reloadData()
        itemData.isHidden = true
        
        
    }
    
    func itemDataSakujyo(){
        // no operation
    }
    
    func isStringContainsOnlyNumbers(string: String) -> Bool {
        return string.trimmingCharacters(in: .decimalDigits).count <= 0
    }
    
    @IBAction func btnItemDataCancel(_ sender: NSButton) {
        tblItem.isEnabled = true
        itemData.isHidden = true
        
    }
    
    
    //-----------------------------item insert,delete,edit
    
    override func prepare(for segue: NSStoryboardSegue, sender: Any?) {
        
        switch segue.identifier!{
        case "showPrefsSisanModal":
            let view = segue.destinationController as! PrefsSisanViewController
            view.delegate = self
        case "showPrefsHimokuModal":
            let view = segue.destinationController as! PrefsHimokuViewController
            view.delegate = self
            
        default:
            print("prepare failed")
        }
    }
    
   
    // for PrefsHimokuViewController
    @IBAction func mnuShowPrefsHimoku(_ sender:Any){
        performSegue(withIdentifier: "showPrefsHimokuModal", sender: nil)
    }
    
    func himokuKoumokuChanged(_ sw:Bool){
        
        if sw {
            //someMessageWithAlert("from HimoukuKoumokuChanged ")
            tblSisan.reloadData()
            tblItem.reloadData()
        }

    }
    //------------------------------- for PrefsHimokuViewController
    
    
    func sisanKoumokuChanged(_ sw:Bool){
        if sw {
            tblSisan.reloadData()
            tblItem.reloadData()
        }
    }

    @IBAction func mnuShowPrefsSisan(_ sender:Any){
        performSegue(withIdentifier: "showPrefsSisanModal", sender: nil)
    }
    //------------------------------------ PrefsSisanViewController
    
    
    func someMessageWithAlert(_ message: String, _ textInfo:String = "information") {
        let alert = NSAlert()
        alert.messageText = message
        alert.informativeText = textInfo
        alert.runModal()
    }
    
    func yesNoMessageWithAlert(_ message:String, _ yesTitle:String, _ noTitle:String) -> Bool{
        //Yes: return true, No:return false
        let alert = NSAlert()
        alert.messageText = message
        alert.addButton(withTitle: yesTitle)// = 1000
        alert.addButton(withTitle: noTitle)   // = 1001
        if alert.runModal().rawValue == 1000{
            return true
        }else{
            return false
        }

    }

}

