//
//  MyPDFPage.swift
//  prjCreatePDF
//
//  Created by 梅山 新一郎 on 2018/10/16.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa
import Quartz

class MyPDFPage: PDFPage {
    
    var dataName:[String] = []
    var dataAmount:[[Int]] = []
    
    
//    var name_totalWidth = CGFloat(160)
//    var tableWidth = CGFloat(0)
    var numberOfDatasRowsPerPage:Int = 0
    var numberOfRowsPerPage:Int  = 0
    var pageWidth = CGFloat(0)
    var pageHeight = CGFloat(0)
    
    init(numberOfDatasRowsPerPage:Int, numberOfRowsPerPage:Int, dataname:[String], dataamount:[[Int]]){
        
        super.init()
        
        self.numberOfDatasRowsPerPage = numberOfDatasRowsPerPage
        self.numberOfRowsPerPage = numberOfRowsPerPage
        self.dataName = dataname
        self.dataAmount = dataamount
        
        self.numberOfDatasRowsPerPage = numberOfDatasRowsPerPage
        self.numberOfRowsPerPage = numberOfRowsPerPage
        self.pageWidth = leftMargin + tableWidth + rightMargin
        self.pageHeight = topMargin + rowHeight * CGFloat( self.numberOfRowsPerPage) + bottomMargin
        
    }
    
    
    override func draw(with box: PDFDisplayBox) {
        super.draw(with: box)
        self.drawTableLines()
        self.drawTableData()
    }
    
    func drawTableLines(){
        var p00 = NSMakePoint(leftMargin , self.pageHeight - topMargin)
        var p01 = NSMakePoint(leftMargin + tableWidth, self.pageHeight - topMargin)
        var p10 = NSMakePoint(leftMargin , self.pageHeight - topMargin)
        var p11 = NSMakePoint(leftMargin , self.pageHeight - topMargin - rowHeight * CGFloat(numberOfDatasRowsPerPage + 1))
        
        drawLine(linewidth: CGFloat(2), from: p10, to: p11)
        p10.x += name_totalWidth; p11.x += name_totalWidth
        for _ in 1...2{
            drawLine(linewidth: CGFloat(2), from: p00, to: p01)
           
            for _ in 1...6{
                drawLine(linewidth: CGFloat(0.5), from: p10, to: p11)
                p10.x += columnWidth; p11.x += columnWidth
            }
            p00.y -= rowHeight; p01.y -= rowHeight
            drawLine(linewidth: CGFloat(2), from: p00, to: p01)
            for _ in 1...3{
                p00.y -= rowHeight * 5; p01.y -= rowHeight * 5
                drawLine(linewidth: CGFloat(0.5), from: p00, to: p01)
                
            }
            p00.y -= rowHeight * 5; p01.y -= rowHeight * 5
            drawLine(linewidth: CGFloat(2), from: p00, to: p01)
            p00.y -= rowHeight * CGFloat(spaceTables); p01.y -= rowHeight * CGFloat(spaceTables)
            p10.x = leftMargin + columnWidth; p11.x = leftMargin + columnWidth
            p10.y = self.pageHeight - topMargin - rowHeight * CGFloat(numberOfDatasRowsPerPage + 1 + spaceTables)
            p11.y = self.pageHeight - topMargin - rowHeight * CGFloat((numberOfDatasRowsPerPage + 1) * 2 + spaceTables)
        }
        p10.x  = leftMargin + tableWidth; p11.x = leftMargin + tableWidth
        p10.y = self.pageHeight - topMargin - rowHeight * CGFloat(numberOfDatasRowsPerPage + 1 + spaceTables)
        p11.y = self.pageHeight - topMargin - rowHeight * CGFloat((numberOfDatasRowsPerPage + 1) * 2 + spaceTables)
        drawLine(linewidth: CGFloat(2), from: p10, to: p11)

    }
    
    func drawTableData(){
        //-----------------------------------------------------column title
        let titleFont = NSFont(name:"Helvetica", size: 11.0)

        var p0 = NSMakePoint(leftMargin + textInset + textInset, self.pageHeight - verticalPadding - topMargin - rowHeight)
        var s0Rect = NSMakeRect(p0.x, p0.y, name_totalWidth, rowHeight)
        "  名称".draw(in: s0Rect, withAttributes: [NSAttributedString.Key.font: titleFont!])
        
        p0.x += name_totalWidth
        var p1 = NSMakePoint(leftMargin + textInset + textInset, self.pageHeight - verticalPadding - topMargin - rowHeight * CGFloat( numberOfDatasRowsPerPage + 2 + spaceTables))
        
        for m in 1...6{
            let s1Rect = NSMakeRect(p0.x, p0.y, columnWidth, rowHeight)
            let s2Rect = NSMakeRect(p1.x, p1.y, columnWidth, rowHeight)
            let s1 = String(format: "%4d 月", m);let s2 = String(format: "%4d 月", m + 6)
            s1.draw(in: s1Rect, withAttributes: [NSAttributedString.Key.font: titleFont!])
            s2.draw(in: s2Rect, withAttributes: [NSAttributedString.Key.font: titleFont!])
            p0.x += columnWidth; p1.x += columnWidth
            
        }
        s0Rect = NSMakeRect(p1.x, p1.y, name_totalWidth, rowHeight)
        "       合計".draw(in: s0Rect, withAttributes: [NSAttributedString.Key.font: titleFont!])

        //------------------------------------------ name
         p0 = NSMakePoint(leftMargin + textInset, self.pageHeight - verticalPadding - topMargin - rowHeight - rowHeight)
         p1 = NSMakePoint(leftMargin + textInset, self.pageHeight - topMargin - rowHeight * CGFloat( numberOfDatasRowsPerPage + spaceTables))
        
        let nameFont = NSFont(name:"Helvetica", size: 10.0)
        for s in dataName{
            let nameRect = NSMakeRect(p0.x, p0.y,  name_totalWidth,  rowHeight)
            
            s.draw(in: nameRect, withAttributes: [NSAttributedString.Key.font: nameFont!])
            p0.y -= rowHeight
        }
        //----------------------------------------- each data
        let amountFont = NSFont(name: "Helvetica", size: 8.0)
        p0 = NSMakePoint(leftMargin + name_totalWidth + textInset + textInset, self.pageHeight - verticalPadding - topMargin - rowHeight - rowHeight)
        p1 = NSMakePoint(leftMargin + textInset + textInset, self.pageHeight - verticalPadding - topMargin - rowHeight * CGFloat( numberOfDatasRowsPerPage + 2 + spaceTables + 1))
        for line in dataAmount{
            for i in 0...5{
                let a1Rect = NSMakeRect(p0.x, p0.y, columnWidth, rowHeight)
                let a2Rect = NSMakeRect(p1.x, p1.y , columnWidth, rowHeight)
                int2stringWithComma(integer: line[i]).draw(in: a1Rect, withAttributes: [NSAttributedString.Key.font: amountFont!])
                int2stringWithComma(integer: line[i + 6]).draw(in: a2Rect, withAttributes: [NSAttributedString.Key.font: amountFont!])
                p0.x += columnWidth; p1.x += columnWidth

            }
            let a0Rect = NSMakeRect(p1.x, p1.y, name_totalWidth, rowHeight)
            int2stringWithComma(integer: line[12]).draw(in: a0Rect, withAttributes: [NSAttributedString.Key.font: amountFont!])
            p0.x = leftMargin + name_totalWidth + textInset + textInset
            p1.x = leftMargin + textInset + textInset
            p0.y -= rowHeight; p1.y -= rowHeight
        }
    }
    func drawLine(linewidth: CGFloat, from:NSPoint, to:NSPoint){
        let path = NSBezierPath()
        NSColor.darkGray.set()
        path.move(to: to)
        path.line(to: from)
        path.lineWidth = linewidth
        path.stroke()
    }
    
    
    func int2stringWithComma(integer:Int, digits:Int  = 10) -> String{
        var s = ""
        for _ in 1...digits{ s += " " }
        let formatter = NumberFormatter()
        formatter.numberStyle = .decimal
        s += formatter.string(from: integer as NSNumber) ?? "error"
        return String(s.suffix(digits))
    }
}

//    override func bounds(for box: PDFDisplayBox) -> NSRect {
//        return NSMakeRect(0,  0, pageWidth, pageHeight)
//    }
