//
//  ViewController.swift
//  prjCreatePDF
//
//  Created by 梅山 新一郎 on 2018/10/14.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa
import Quartz

class ViewController: NSViewController, NSTableViewDataSource, NSTableViewDelegate {

    
    let DM = DataModel.sharedInstance
    
    override func viewDidLoad() {
        super.viewDidLoad()
        tblTestData.dataSource = self
        tblTestData.delegate = self
    }

    override var representedObject: Any? {
        didSet {
        // Update the view, if already loaded.
        }
    }

    @IBAction func btnCreatePDF(_ sender: Any) {
        
        let aPdfDoc = PDFDocument()
        var numberOfPages = DM.testDataName.count / numberOfDatasRowsPerPage
        if DM.testDataName.count % numberOfDatasRowsPerPage > 0{
            numberOfPages += 1
        }
        
        for i in 0 ..< numberOfPages{
            let startIndex = i * numberOfDatasRowsPerPage
            var endIndex = i * numberOfDatasRowsPerPage + numberOfDatasRowsPerPage
            if endIndex >  DM.testDataName.count{
                endIndex = DM.testDataName.count
            }
            
            let pdfDataName:[String] = Array(DM.testDataName[startIndex..<endIndex])
            let pdfDataAmount:[[Int]] = Array(DM.testDataAmount[startIndex..<endIndex])
            let aPage = MyPDFPage(numberOfDatasRowsPerPage: numberOfDatasRowsPerPage, numberOfRowsPerPage: numberOfRowsPerPage, dataname: pdfDataName, dataamount: pdfDataAmount)
            aPdfDoc.insert(aPage, at: i)
        
        }
        
        let FS = NSSavePanel()
        FS.canCreateDirectories = true
        FS.allowedFileTypes = ["pdf", "PDF"]
        if FS.runModal() == NSApplication.ModalResponse.OK{
            let fileURL = FS.url
            let strFS = (fileURL?.path)!
            print(strFS)
            aPdfDoc.write(toFile: strFS)
        }
        //aPdfDoc.write(toFile: "/Users/umeya/Desktop/temp/aPrjCreatePDF.pdf")
        
    }
    
    
    
    
    
    
    
    
    
    
    //------------------- table view
    @IBOutlet weak var tblTestData: NSTableView!
    func numberOfRows(in tableView: NSTableView) -> Int {
        return DM.testDataName.count
    }
    func tableView(_ tableView: NSTableView, heightOfRow row: Int) -> CGFloat {
        return 20
    }
    
    let dctTableColumnID = ["name":0, "m01":1  , "m02":2  , "m03":3  , "m04":4  , "m05":5  , "m06":6  , "m07":7  , "m08":8  , "m09":9  , "m10":10  , "m11":11  , "m12":12  , "total":13]
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        
        if let idx = dctTableColumnID[(tableColumn?.identifier.rawValue)!] {
            if idx == 0{
                vw.textField?.stringValue = DM.testDataName[row]
            }else{
                vw.textField?.integerValue = DM.testDataAmount[row][idx - 1]
            }
        }else{
            return nil
        }
        
        return vw
        
    }
}


    
    


