//
//  DrawAndPrint.swift
//  prjPrintingWithView
//
//  Created by 梅山 新一郎 on 2018/10/12.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa

class DrawAndPrint: NSViewController {

    let DM = DataModel.sharedInstance
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do view setup here.
    }
    
    @IBOutlet weak var cvwDrawPrint: NSView!
    
    @IBAction func btnDrawLinesAndTexts(_ sender: Any) {
        cvwDrawPrint.addSubview(DrawLinesTexts(frame: NSRect(x:0,  y:0, width: cvwDrawPrint.bounds.width, height: cvwDrawPrint.bounds.height),dataName: DM.testDataName, dataAmount: DM.testDataAmount))
    }
    
    @IBAction func btnClear(_ sender: Any) {
        for subvw in cvwDrawPrint.subviews {
            subvw.removeFromSuperview()
        }
    }
    
    @IBAction func btnPrint(_ sender: Any) {
        let printInfo = NSPrintInfo.shared
        printInfo.scalingFactor = CGFloat(0.55)
        printInfo.orientation = NSPrintInfo.PaperOrientation(rawValue: 1)!
        printInfo.paperName = NSPrinter.PaperName("A4")
        let op = NSPrintOperation(view: cvwDrawPrint, printInfo: printInfo)
        op.printPanel.options = NSPrintPanel.Options.showsPaperSize
        op.printPanel.options = NSPrintPanel.Options.showsPreview
        
        op.run()

    }
}




class DrawLinesTexts:NSView{
    var dataName:[String] = []
    var dataAmount:[[Int]] = []
    init(frame:NSRect, dataName:[String], dataAmount:[[Int]]){
        super.init(frame: frame)
        self.dataName = dataName
        self.dataAmount = dataAmount
    }
    
    required init?(coder decoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    override func draw(_ r: NSRect) {
        
        //draw lines
        let path = NSBezierPath()
        path.lineWidth = 3.0
        NSColor.black.setStroke()
        let x_right = r.width - CGFloat(10)
        let x_left = CGFloat(10)
        let name_width = CGFloat(160)
        let total_width = CGFloat(100)
        let amount_digits = 9
        let x_width = CGFloat((x_right - x_left - name_width - total_width) / 12.0)
        let y_height = CGFloat((r.height - 50) / 36.0)
        
        
        path.move(to: NSPoint(x: 5, y: r.height-5))
        path.line(to: NSPoint(x: r.width-5, y: r.height-5))
        path.line(to: NSPoint(x: r.width-5, y: 5))
        path.line(to: NSPoint(x: 5, y: 5))
        path.line(to: NSPoint(x: 5, y: r.height - 5))
        path.move(to: NSPoint(x: 5, y: r.height - 2 - y_height * 2))
        path.line(to: NSPoint(x: r.width-5, y: r.height - 2 - y_height * 2 ))
        path.stroke()
        path.lineWidth = 1.0
        
        var yy = r.height - y_height * 2
        for row in 1...7{
            let y = yy - y_height * CGFloat(row * 5)
            path.move(to: NSPoint(x: x_left, y:  y))
            path.line(to: NSPoint(x: x_right, y: CGFloat(y)))
            path.stroke()
        }
        
        let dashes:[CGFloat] = [3,2]
        path.setLineDash(dashes, count: dashes.count, phase: 0)
        for row in 1...35{
            let y = yy - y_height * CGFloat(row)
            path.move(to: NSPoint(x: x_left, y:  y))
            path.line(to: NSPoint(x: x_right, y: CGFloat(y)))
            path.stroke()
        }
        
        //draw texts
        yy = r.height - 10 - y_height * 1
        "   name".draw(at:CGPoint(x:x_left, y:yy), withAttributes:[NSAttributedString.Key.foregroundColor: NSColor.blue,NSAttributedString.Key.font: NSFont.systemFont(ofSize: 10),])
        var xx = x_left + name_width + 6
        for i in 1...12{
            let s = String(format:"%3d 月",i)
            s.draw(at:CGPoint(x:xx, y:yy), withAttributes:[NSAttributedString.Key.foregroundColor: NSColor.blue,NSAttributedString.Key.font: NSFont.systemFont(ofSize: 10),])
            xx += x_width
        }
        "   合計".draw(at:CGPoint(x:xx, y:yy), withAttributes:[NSAttributedString.Key.foregroundColor: NSColor.blue,NSAttributedString.Key.font: NSFont.systemFont(ofSize: 10),])
        
        yy = r.height - y_height * 2
        for (row, amounts) in dataAmount.enumerated(){
            let y = yy - y_height * CGFloat(row + 1)
            String(dataName[row]).draw(at:CGPoint(x:x_left, y:y), withAttributes:[NSAttributedString.Key.foregroundColor: NSColor.blue,NSAttributedString.Key.font: NSFont.systemFont(ofSize: 10),])
            var x = x_left + name_width
            for amount in amounts{
                let s = int2stringWithComma(integer: amount, digits: amount_digits)
                //let s = ("          " + amount.withComma).suffix(amount_count)
                String(s).draw(at:CGPoint(x:x, y:y), withAttributes:[NSAttributedString.Key.foregroundColor: NSColor.blue,NSAttributedString.Key.font: NSFont.systemFont(ofSize: 10),])
                x += x_width
            }
        }
    }
    
    func int2stringWithComma(integer:Int, digits:Int  = 10) -> String{
        var s = ""
        for _ in 1...digits{ s += " " }
        let formatter = NumberFormatter()
        formatter.numberStyle = .decimal
        s += formatter.string(from: integer as NSNumber) ?? "error"
        return String(s.suffix(digits))
    }
}
