//
//  ViewController.swift
//  prjSQLite3
//
//  Created by 梅山 新一郎 on 2018/09/07.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa

class ViewController: NSViewController,NSTableViewDataSource, NSTableViewDelegate {

    let DM = DataModel.sharedInstance
    private var selRowNo = -1
    
    override func viewDidLoad() {
        super.viewDidLoad()

        tblTest1.dataSource = self
        tblTest1.delegate = self
    }

    @IBOutlet weak var tblTest1: NSTableView!
    @IBOutlet weak var txtNoTest1: NSTextField!
    @IBOutlet weak var txtNameTest1: NSTextField!
    @IBAction func btnAddTest1(_ sender: NSButton) {
        guard DM.insertDB(no: txtNoTest1.integerValue, name: txtNameTest1.stringValue) else{
            return
        }
        reloadDataAndCleartext()
    }
    @IBAction func btnDeleteTest1(_ sender: NSButton) {
        guard selRowNo != -1 else{return}
        guard DM.deleteDB(id: DM.testData1[selRowNo].Id) else{return}
        
        reloadDataAndCleartext()
        deselectRow()
    }
    @IBAction func btnEditTest1(_ sender: NSButton) {
        guard selRowNo != -1 else{return}
        guard DM.updateDB(id: DM.testData1[selRowNo].Id, no: txtNoTest1.integerValue, name: txtNameTest1.stringValue) else{return}
        
        reloadDataAndCleartext()
        deselectRow()
    }
    
    func reloadDataAndCleartext(){
        tblTest1.reloadData()
        txtNoTest1.stringValue = ""
        txtNameTest1.stringValue = ""
    }
    func deselectRow(){
        tblTest1.deselectRow(selRowNo)
        selRowNo = -1
    }
    // tableView ----------------------------------------
    func numberOfRows(in tableView: NSTableView) -> Int {
        return DM.testData1.count
    }

    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {

        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}

        if tableColumn!.identifier.rawValue == "col0"{
            vw.textField?.integerValue = DM.testData1[row].Id
        }else if tableColumn!.identifier.rawValue == "col1"{
            vw.textField?.integerValue = DM.testData1[row].No
        }else if tableColumn!.identifier.rawValue == "col2"{
            vw.textField?.stringValue = DM.testData1[row].Name
        }else{
            return nil
        }
        return vw
    }
    
    func tableViewSelectionIsChanging(_ notification: Notification) {
        selRowNo = tblTest1.selectedRow
        guard selRowNo != -1 else {return}
        
        txtNoTest1.integerValue = DM.testData1[selRowNo].No
        txtNameTest1.stringValue = DM.testData1[selRowNo].Name
    }
    
}

