//
//  HontenViewController.swift
//  prjSplitView
//
//  Created by 梅山 新一郎 on 2018/09/21.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa

class HontenViewController: NSViewController,NSTableViewDataSource, NSTableViewDelegate {
    
    let DM = DataModel.sharedInstance
    

    override func viewDidLoad() {
        super.viewDidLoad()
        tblHontan.dataSource = self
        tblHontan.delegate = self
    }
    
    @IBOutlet weak var cmbTenmei: NSComboBox!
    
    @IBOutlet weak var txtKingaku: NSTextField!
    
    @IBAction func btnSoukin(_ sender: Any) {
        let idxTenmei = cmbTenmei.indexOfSelectedItem
        guard idxTenmei != -1 else{return}
        
        guard let spvc = parent as? NSSplitViewController else{return}
        
        if idxTenmei == 0 { // from honten to sitenA
            DM.soukin(sendFrom: "本店", sendTo: "支点A", kingaku: txtKingaku.integerValue)
            if let toVC = spvc.children[1] as? SitenAViewController {
                toVC.refreshTable()
            }
        }else if idxTenmei == 1 { // honten to sitenB
            DM.soukin(sendFrom: "本店", sendTo: "支点B", kingaku: txtKingaku.integerValue)
            if let toVC = spvc.children[2] as? SitenBViewController {
                toVC.refreshTable()
            }
        }else{
            return
        }
        tblHontan.reloadData()
    }
    func refreshTable(){
        tblHontan.reloadData()
    }
    @IBOutlet weak var tblHontan: NSTableView!
    
    func numberOfRows(in tableView: NSTableView) -> Int {
        return DM.hontenList.count
    }
    
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        
        switch tableColumn!.identifier.rawValue {
        case "tenmei":
            vw.textField?.stringValue = DM.hontenList[row].namae
        case "kingaku":
            vw.textField?.integerValue = DM.hontenList[row].kingaku
            
        default:
            return nil
        }
        return vw
    }
}
