//
//  SitenAViewController.swift
//  prjSplitView
//
//  Created by 梅山 新一郎 on 2018/09/21.
//  Copyright © 2018年 Umeya. All rights reserved.
//

import Cocoa

class SitenAViewController: NSViewController,NSTableViewDataSource, NSTableViewDelegate  {

    let DM = DataModel.sharedInstance
    
    override func viewDidLoad() {
        super.viewDidLoad()
        tblSitenA.dataSource = self
        tblSitenA.delegate = self
    }
    
    @IBOutlet weak var cmbTenmei: NSComboBox!
    
    @IBOutlet weak var txtKingaku: NSTextField!
    
    @IBAction func btnSoukin(_ sender: Any) {
        let idxTenmei = cmbTenmei.indexOfSelectedItem
        guard idxTenmei != -1 else{return}
        
        guard let spvc = parent as? NSSplitViewController else{return}
        
        if idxTenmei ==  0{ // from sitenA  to honten
            DM.soukin(sendFrom: "支点A", sendTo: "本店", kingaku: txtKingaku.integerValue)
            if let toVC = spvc.children[0] as? HontenViewController {
                toVC.refreshTable()
            }
        }else if idxTenmei == 1 { // from sitenA to sitenB
            DM.soukin(sendFrom: "支点A", sendTo: "支点B", kingaku: txtKingaku.integerValue)
            if let toVC = spvc.children[2] as? SitenBViewController {
                toVC.refreshTable()
            }
        }else{
            return
        }
        tblSitenA.reloadData()
    }
    
    func refreshTable(){
        tblSitenA.reloadData()
    }
    
    @IBOutlet weak var tblSitenA: NSTableView!
    func numberOfRows(in tableView: NSTableView) -> Int {
        return DM.sitenAList.count
    }
    
    
    func tableView(_ tableView: NSTableView, viewFor tableColumn: NSTableColumn?, row: Int) -> NSView? {
        guard let vw = tableView.makeView(withIdentifier: tableColumn!.identifier, owner: self) as? NSTableCellView else {return nil}
        
        switch tableColumn!.identifier.rawValue {
        case "tenmei":
            vw.textField?.stringValue = DM.sitenAList[row].namae
        case "kingaku":
            vw.textField?.integerValue = DM.sitenAList[row].kingaku
            
        default:
            return nil
        }
        return vw
    }
    
}
